import processing.core.*; 
import processing.xml.*; 

import controlP5.*; 
import processing.opengl.*; 
import java.util.*; 
import java.util.*; 

import java.applet.*; 
import java.awt.Dimension; 
import java.awt.Frame; 
import java.awt.event.MouseEvent; 
import java.awt.event.KeyEvent; 
import java.awt.event.FocusEvent; 
import java.awt.Image; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class B01_Catenary_Surface_Simulator extends PApplet {




//for closth simulation
//for seaching 3D coordinnate from 2D coordinate
PGraphics bf;
float expo = 1;
float rotx, roty;
float rate = 0.01f;
float c1_x = 0;
float c1_y = 0;
float c1_z = 0;

int c1, c2;
PFrame f;
secondApplet s;

ParticleSystem physics;
Particle[][] particles;
Particle currentParticle;
PVector currentParticle_2;
Particle [][] triangles;
Particle [][] quadrangles;
int [] quads;

int sizeOfCol = 25;//sizeOfCol = 30;
int sizeOfRow = 25;
float interval_col = 10.0f;
float interval_row = 10.0f;
float massOfParticle = 300/sizeOfCol*sizeOfRow;

int Cloth_x = sizeOfCol;
int Cloth_y = sizeOfRow;

float SPRING_STRENGTH = 100;
float SPRING_DAMPING = 0;

boolean cloth = true;
boolean startSim = true;
boolean hunger_display = true;
boolean signOfHunger2 = false;
boolean isFaces = true;

int col = 0;
int row = 0;
int [][] displaySignOfParticles; 

int hunger_x = 7;
int hunger_y = 10;

int subWindow_x = PApplet.parseInt(sizeOfCol*interval_col*0.8f);
int subWindow_y = PApplet.parseInt(sizeOfRow*interval_row*0.8f);

ControlP5 controlP5;

public int TRANSPARENCY = 255;

int[] anchor  = new int[50];
int anchornum = 0;
int[] force = new int[50];
int forcenum = 0;
int[] skelton = new int[500];


boolean sub_display = false;

public void setup() {
  sizeOfCol = Cloth_x;
  sizeOfRow = Cloth_y;
  size(700, 700, OPENGL);
//  colorMode(HSB, 255);
  smooth();
  //for cloth simulation
  bf = createGraphics(width, height, P3D);
  physics = new ParticleSystem(0.0f, 0.0f, 9.8f, 30);//(gravity,drag)
  setInitialCloth();
  //  drawSubWindow();
  setQuads();

  //  axis = new Axis(60,60,60);
  force[forcenum] = particles[sizeOfCol/2-1][sizeOfRow/2-1].id;
  forcenum = forcenum + 1;
  setController();
}

public void draw() {
  background(100);
  lights();
  stroke(0);
  translate(width/2, height/1.6f);
  rotateX(rotx);
  rotateY(roty);
  scale(expo);
  drawPointer();
  drawPGraphics();
  if (isFaces) drawFaces();
  if (cloth) drawCloth();
  if (startSim) physics.tick(1.5f);//speed of simulation
  if (hunger_display) drawHunger(0);
  //  if(signOfHunger2) drawHunger(200);
  // axis.display();
  setQuads();
  gui();
}

public void resize_cloth() {
  setSpring();
  setup();
}

public void setSpring() {
  for (int i=0; i<physics.springs.size(); i++) {
    Spring tmp = (Spring)physics.springs.get(i);
    tmp.setStrength(SPRING_STRENGTH);
    tmp.setDamping(SPRING_DAMPING);
  }
}

public void drawSubWindow() {
  float scaleRate = 0.6f;
  pushMatrix();
  translate(width-(30+sizeOfCol*interval_col*scaleRate), 50, 0);

  for (int i=0; i<physics.springs.size(); i++) {
    Spring currentSpring = (Spring)physics.springs.get(i);
    Particle p1 = currentSpring.a;
    Particle p2 = currentSpring.b;
    stroke(0, 0, 0, 50);
    line(p1.initialPosition.x()*scaleRate, p1.initialPosition.y()*scaleRate, p2.initialPosition.x()*scaleRate, p2.initialPosition.y()*scaleRate);
  }

  for (int i=0; i<sizeOfCol; i++) {
    for (int j=0; j<sizeOfRow; j++) {
      if (particles[i][j].dead == false) {
        stroke(0);
        if (particles[i][j].isFixed()) {
          stroke(255, 255, 0, 100);
          fill(255, 255, 0, 100); 
          ellipse(particles[i][j].initialPosition().x()*scaleRate, particles[i][j].initialPosition().y()*scaleRate, 4, 4);
        }
        else { 
          point(particles[i][j].initialPosition().x()*scaleRate, particles[i][j].initialPosition().y()*scaleRate);
        }
      }
    }
  }
  fill(255, 255, 0);
  ellipse(c1_x*scaleRate, c1_y*scaleRate, 6*scaleRate, 6*scaleRate);
  popMatrix();
}

public class PFrame extends Frame {
  public PFrame() {
    setBounds(1000, 0, subWindow_x, subWindow_y);
    s = new secondApplet();
    add(s);
    s.init();
    show();
  }
}

public class secondApplet extends PApplet {
  public void setup() {
    size(subWindow_x, subWindow_y);
    noLoop();
  }
  public void draw() {
  }
}

public void setCurrentParticle() {
  int c1 = bf.get(mouseX, mouseY);
  int c2 = color(0);

  if (c1 > c2) { //pointer visualizer 

    float c2_x = red(c1) * 3;
    float c2_y = green(c1) * 3;
    float c2_z = blue(c1) * 3;

    for (int i=0; i<sizeOfCol; i++) {
      for (int j=0; j<sizeOfRow; j++) {
        if (c2_x - 5 < particles[i][j].position.x() && particles[i][j].position.x() < c2_x + 5 &&
          c2_y - 5 < particles[i][j].position.y() && particles[i][j].position.y() < c2_y + 5 &&
          c2_z - 5 < particles[i][j].position.z() && particles[i][j].position.z() < c2_z + 5) {
          currentParticle = particles[i][j];
        }
      }
    }
    currentParticle_2.set(c2_x, c2_y, c2_z);
    currentParticle.position.set(currentParticle_2.x, currentParticle_2.y, currentParticle_2.z);
  }
}

public void setInitialCloth() {
  particles = new Particle[sizeOfCol][sizeOfRow];
  displaySignOfParticles = new int[sizeOfCol][sizeOfRow];
  Spring[] currentSpring = new Spring[1];

  //initial arrangement of particles  
  int id = 1;
  for (int i = 0; i<sizeOfCol; i++) {
    for (int j = 0; j<sizeOfRow; j++) {
      particles[i][j] = physics.makeParticle(id, massOfParticle, i*interval_col+10, j*interval_row+10, 0.0f );
      if (j > 0) physics.makeSpring(particles[i][j-1], particles[i][j], SPRING_STRENGTH, SPRING_DAMPING, interval_col);//rows
      id = id + 1;
    }
  }

  //settings of springs of particles  
  for (int j = 0; j < sizeOfRow; j++) {
    for (int i = 0; i < sizeOfCol; i++) {
      if (i > 0) physics.makeSpring(particles[i - 1][j], particles[i][j], SPRING_STRENGTH, SPRING_DAMPING, interval_row);//colums
      if (i+1 < sizeOfCol && j+1 < sizeOfRow) physics.makeSpring(particles[i][j], particles[i+1][j+1], SPRING_STRENGTH, SPRING_DAMPING, interval_col*sqrt(2));//\u659c\u3081\u53f3
      if (j > 0 && i+1 < sizeOfCol) physics.makeSpring(particles[i][j], particles[i+1][j-1], SPRING_STRENGTH, SPRING_DAMPING, interval_row*sqrt(2));//\u659c\u3081\u5de6
    }
  }

  //settings of fixed points  
  particles[0][0].makeFixed();
  anchor[anchornum] = particles[0][0].id;
  anchornum = anchornum + 1;

  particles[0][sizeOfRow - 1].makeFixed();
  anchor[anchornum] = particles[0][sizeOfRow - 1].id;
  anchornum = anchornum + 1;

  particles[sizeOfCol - 1][0].makeFixed();
  anchor[anchornum] = particles[sizeOfCol - 1][0].id;
  anchornum = anchornum + 1;

  particles[sizeOfCol - 1][sizeOfRow - 1].makeFixed();
  anchor[anchornum] = particles[sizeOfCol - 1][sizeOfRow - 1].id;
  anchornum = anchornum + 1;

  currentParticle = particles[0][0];
  currentParticle_2 = new PVector(0, 0, 0);
}

public void drawPGraphics() {
  bf.beginDraw();
  bf.background(255);
  bf.translate(width/2, height/1.6f);
  bf.rotateX(rotx);
  bf.rotateY(roty);
  bf.scale(expo);

  for (int j = 0; j < sizeOfRow; j++) {
    for (int i = 0; i < sizeOfCol; i++) {
      bf.pushMatrix();
      bf.translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
      bf.translate(particles[i][j].position().x(), particles[i][j].position().y(), particles[i][j].position().z());
      bf.noStroke();
      bf.fill(particles[i][j].position().x()/3, particles[i][j].position().y()/3, particles[i][j].position().z()/3);
      bf.ellipse(0, 0, 10, 10);//box size determine the eria of pointer 
      bf.popMatrix();
    }
  }
}

public void drawPointer() {
  c1 = bf.get(mouseX, mouseY);
  c2 = color(0);

  if (c1 > c2) { //pointer visualizer 
    c1_x = red(c1) * 3;
    c1_y = green(c1) * 3;
    c1_z = blue(c1) * 3;   
    pushMatrix();
    translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
    translate(c1_x, c1_y, c1_z);
    fill(c1_x, c1_y, c1_z);
    ellipse(0, 0, 10, 10);
    ;
    popMatrix();
  }
}

public void drawCloth() {
  //  stroke(0);
  //  fill(0,0,0,100);
  //  float eSize = 0;
  //  for(int i=0; i<physics.particles.size(); i++) {
  //    Particle tempParticle = (Particle)physics.particles.get(i);
  //    if(tempParticle.isFixed()) {
  //      fill(255,255,255,100); 
  //      eSize = interval_col/3;
  //    }
  //    else {
  //      fill(0,0,0,100); 
  //      eSize = interval_col/6;
  //    }
  //    pushMatrix();
  //    translate(-sizeOfCol*interval_col/2,-sizeOfRow*interval_row/2,0);
  //    translate(tempParticle.position().x(), tempParticle.position().y(),tempParticle.position().z());
  ////    ellipse(0, 0, eSize, eSize);
  //    popMatrix();
  //  }

  stroke(0,100);
  pushMatrix();
  translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
  for (int i=0; i<physics.springs.size(); i++) {
    Spring currentSpring = (Spring)physics.springs.get(i);
    Particle p1 = currentSpring.a;
    Particle p2 = currentSpring.b;
    line(p1.position.x(), p1.position.y(), p1.position.z(), p2.position.x(), p2.position.y(), p2.position.z());
  }
  popMatrix();

  fill(255, 255, 0, 50);
  pushMatrix();
  translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
  translate(currentParticle.position.x, currentParticle.position.y, currentParticle.position.z);
  ellipse(0, 0, interval_col/2, interval_row/2);
  popMatrix();

  pushMatrix();
  translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
  translate(currentParticle_2.x, currentParticle_2.y, currentParticle_2.z);
  ellipse(0, 0, interval_col/2, interval_row/2);
  popMatrix();
}


public void drawHunger(float height) {
  fill(200, 125);
  noStroke();
  float root = (float)Math.sqrt(3);

  for (int i=0; i<hunger_x; i++) {
    for (int j=0; j<hunger_y; j++) {
      pushMatrix();
      translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
      translate(30*root*i, 30*j, height);
      ellipse(0, 0, interval_col/2, interval_row/2);
      popMatrix();
    }
  }

  for (int i=0; i<hunger_x-1; i++) {
    for (int j=0; j<hunger_y-1; j++) {
      pushMatrix();
      translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
      translate(15 * root, 15, 0.0f);
      translate(30 * root * i, 30*j, height);
      ellipse(0, 0, interval_col/2, interval_row/2);
      popMatrix();
    }
  }

  bf.noStroke();
  for (int i=0; i<hunger_x; i++) {
    for (int j=0; j<hunger_y; j++) {
      //      float root = (float)Math.sqrt(3);
      bf.pushMatrix();
      bf.translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
      bf.fill(30*root*i/3, 30*j/3, height/3);
      bf.translate(30*root*i, 30*j, height);
      bf.ellipse(0, 0, 10, 10);
      bf.popMatrix();
    }
  }

  for (int i=0; i<hunger_x-1; i++) {
    for (int j=0; j<hunger_y-1; j++) {
      //      float root = (float)Math.sqrt(3);
      bf.pushMatrix();
      bf.translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
      bf.fill((30*root*i+15*root)/3, (30*j + 15)/3, height/3);
      bf.translate(15 * root, 15, 0.0f);
      bf.translate(30 * root * i, 30*j, height);
      bf.ellipse(0, 0, 10, 10);
      bf.popMatrix();
    }
  }
}

public void drawFaces() {
  pushMatrix();
  noStroke();
  translate(-sizeOfCol*interval_col/2, -sizeOfRow*interval_row/2, 0);
  fill(255,0,0,180);
  for (int i=0; i<quadrangles.length; i++) {
    if (quadrangles[i][0] != null && quadrangles[i][1] != null  && quadrangles[i][2] != null && quadrangles[i][3] != null ) {
      Particle p1 = quadrangles[i][0];
      Particle p2 = quadrangles[i][1];
      Particle p3 = quadrangles[i][2];
      Particle p4 = quadrangles[i][3];
      beginShape(QUADS);
      vertex(p1.position.x, p1.position.y, p1.position.z);
      vertex(p2.position.x, p2.position.y, p2.position.z);
      vertex(p3.position.x, p3.position.y, p3.position.z);
      vertex(p4.position.x, p4.position.y, p4.position.z);
      endShape(CLOSE);
    }
  }
  popMatrix();
}

public void setQuads() {
  int num = 0;
  quadrangles = new Particle[(sizeOfCol-1)*(sizeOfRow-1)][5];
  quads = new int[(sizeOfCol)*(sizeOfRow)];
  for (int i=0; i<sizeOfCol; i++) {
    for (int j=0; j<sizeOfRow; j++) {
      if (i+1<sizeOfCol && j+1<sizeOfRow) {
        if (particles[i][j].dead != true && particles[i][j+1].dead != true && particles[i+1][j+1].dead != true && particles[i+1][j].dead != true) {
          quadrangles[num][0] = particles[i][j];
          quadrangles[num][1] = particles[i][j+1];
          quadrangles[num][2] = particles[i+1][j+1];
          quadrangles[num][3] = particles[i+1][j]; 
          quads[num] = 1;     
          num++;
        }
        else {
          quadrangles[num][0] = null;
          quadrangles[num][1] = null;
          quadrangles[num][2] = null;
          quadrangles[num][3] = null;
        }
      }
    }
  }
}


public void gui() {
  hint(DISABLE_DEPTH_TEST);
  PMatrix3D currCameraMatrix = new PMatrix3D(((PGraphics3D)g).camera);
  camera();
  controlP5.draw();
  if (sub_display) drawSubWindow();
  ((PGraphics3D)g).camera = currCameraMatrix;
  hint(ENABLE_DEPTH_TEST);
}

public class Attraction implements Force

{

  Particle a;

  Particle b;

  float k;

  boolean on;

  float distanceMin;

  float distanceMinSquared;



  public Attraction( Particle a, Particle b, float k, float distanceMin )

  {

    this.a = a;

    this.b = b;

    this.k = k;

    on = true;

    this.distanceMin = distanceMin;

    this.distanceMinSquared = distanceMin*distanceMin;
  }



  protected void setA( Particle p )

  {

    a = p;
  }



  protected void setB( Particle p )

  {

    b = p;
  }



  public final float getMinimumDistance()

  {

    return distanceMin;
  }



  public final void setMinimumDistance( float d )

  {

    distanceMin = d;

    distanceMinSquared = d*d;
  }



  public final void turnOff()

  {

    on = false;
  }



  public final void turnOn()

  {

    on = true;
  }



  public final void setStrength( float k )

  {

    this.k = k;
  }



  public final Particle getOneEnd()

  {

    return a;
  }



  public final Particle getTheOtherEnd()

  {

    return b;
  }



  public void apply()

  {

    if ( on && ( a.isFree() || b.isFree() ) )

    {

      float a2bX = a.position().x() - b.position().x();

      float a2bY = a.position().y() - b.position().y();

      float a2bZ = a.position().z() - b.position().z();



      float a2bDistanceSquared = a2bX*a2bX + a2bY*a2bY + a2bZ*a2bZ;



      if ( a2bDistanceSquared < distanceMinSquared )

        a2bDistanceSquared = distanceMinSquared;



      float force = k * a.mass * b.mass / a2bDistanceSquared;



      float length = (float)Math.sqrt( a2bDistanceSquared );



      // make unit vector



      a2bX /= length;

      a2bY /= length;

      a2bZ /= length;



      // multiply by force 



      a2bX *= force;

      a2bY *= force;

      a2bZ *= force;



      // apply



      if ( a.isFree() )

        a.force().add( -a2bX, -a2bY, -a2bZ );

      if ( b.isFree() )

        b.force().add( a2bX, a2bY, a2bZ );
    }
  }



  public final float getStrength()

  {

    return k;
  }



  public final boolean isOn()

  {

    return on;
  }



  public final boolean isOff()

  {

    return !on;
  }
}


public void setController(){
  controlP5 = new ControlP5(this);
  controlP5.setAutoDraw(false);
  
  controlP5.addToggle("hunger_display",true,215,100,20,10).setMode(ControlP5.SWITCH);
  controlP5.addSlider("hunger_x", 1, 40, hunger_x, 10, 100, 150, 10);
  controlP5.addSlider("hunger_y", 1, 40, hunger_y, 10, 112, 150, 10);
  controlP5.addToggle("sub_display",false,width-70,10,20,10).setMode(ControlP5.SWITCH);

  controlP5.addSlider("SPRING_STRENGTH", 0, 100, SPRING_STRENGTH, 10, 20, 150, 10);
  controlP5.addSlider("SPRING_DAMPING", 0, 100, SPRING_DAMPING, 10, 32, 150, 10);
  controlP5.addSlider("Cloth_x", 0, 100, Cloth_x, 10, 60, 150, 10);
  controlP5.addSlider("Cloth_y", 0, 100, Cloth_y, 10, 72, 150, 10);
  
  controlP5.addBang("resize_cloth", 215, 60, 20, 20);
}

public void keyPressed() {
  switch(key) {
  case 'u':
    //    setCurrentParticle(); 
    currentParticle.position.set(currentParticle.position.x(), currentParticle.position.y()+1, currentParticle.position.z()); 
    break;
  case 'd': 
    //    setCurrentParticle(); 
    currentParticle.position.set(currentParticle.position.x(), currentParticle.position.y()-1, currentParticle.position.z()); 
    break;
  case 'r':
    //    setCurrentParticle(); 
    currentParticle.position.set(currentParticle.position.x()+1, currentParticle.position.y(), currentParticle.position.z()); 
    break;
  case 'l': 
    //    setCurrentParticle(); 
    currentParticle.position.set(currentParticle.position.x()-1, currentParticle.position.y(), currentParticle.position.z()); 
    break;
  case 'x': 
    setCurrentParticle();
    currentParticle.makeFixed();
    break;
  case 'f': 
    setCurrentParticle();
    currentParticle.makeFree();
    break;
  case 'k': 
    setCurrentParticle();
    currentParticle.dead = true;
    physics.removeParticle(currentParticle);
    physics.removeParticle(currentParticle);
    physics.removeParticle(currentParticle);
    break;
  case 'z': 
    //    setCurrentParticle();
    currentParticle.position.set(currentParticle.position.x(), currentParticle.position.y(), currentParticle.position.z()+10); 
    break;
  case 'w': 
    //    setCurrentParticle();
    currentParticle.position.set(currentParticle.position.x(), currentParticle.position.y(), currentParticle.position.z()-10); 
    break;
  case 'h':
    if(hunger_display) hunger_display = false;
    else hunger_display = true;
    break;
  case 's':
    if(startSim) startSim = false;
    else startSim = true;
    break;
  case '@':
    //    setFaces();
    setQuads();
    break;
  
    case '/':
 if(signOfHunger2) signOfHunger2 = false;
    else signOfHunger2 = true;
    break;
    
    case '^':
 if(isFaces) isFaces = false;
    else isFaces = true;
    break;
    
  case 'a': 
    anchor[anchornum] = currentParticle.id;
    anchornum = anchornum + 1;
    break;
  case ':':
    force[forcenum] = currentParticle.id;
    forcenum = forcenum + 1;
    break;
  }

  switch(keyCode) {
  case UP: 
    expo = expo + 0.05f;
    break;
  case DOWN: 
    expo = expo - 0.05f;
    break;
  }
}

public void mouseClicked() {
  if(mouseY > 200) setCurrentParticle();
}

public void mouseDragged() {
  if(mouseY>200 || mouseX > 300){
  rotx = rotx + (mouseY - pmouseY) * rate;
  roty = roty + (mouseX - pmouseX) * rate;
  }
  setSpring();
}

public interface Integrator 
{

	public void step( float t );

}


public class ModifiedEulerIntegrator implements Integrator

{

	ParticleSystem s;

	

	public ModifiedEulerIntegrator( ParticleSystem s )

	{

		this.s = s;

	}

	

	public void step( float t )

	{

		s.clearForces();

		s.applyForces();

		

		float halftt = 0.5f*t*t;

		

		for ( int i = 0; i < s.numberOfParticles(); i++ )

		{

			Particle p = s.getParticle( i );

			if ( p.isFree() )

			{

				float ax = p.force().x()/p.mass();

				float ay = p.force().y()/p.mass();

				float az = p.force().z()/p.mass();

				

				p.position().add( p.velocity().x()/t, p.velocity().y()/t, p.velocity().z()/t );

				p.position().add( ax*halftt, ay*halftt, az*halftt );

				p.velocity().add( ax/t, ay/t, az/t );

			}

		}

	}



}


public class EulerIntegrator implements Integrator

{

	ParticleSystem s;

	

	public EulerIntegrator( ParticleSystem s )

	{

		this.s = s;

	}

	

	public void step( float t )

	{

		s.clearForces();

		s.applyForces();

		

		for ( int i = 0; i < s.numberOfParticles(); i++ )

		{

			Particle p = (Particle)s.getParticle( i );

			if ( p.isFree() )

			{

				p.velocity().add( p.force().x()/(p.mass()*t), p.force().y()/(p.mass()*t), p.force().z()/(p.mass()*t) );

				p.position().add( p.velocity().x()/t, p.velocity().y()/t, p.velocity().z()/t );

			}

		}

	}
}


public interface Force
{
	public void turnOn();
	public void turnOff();
	public boolean isOn();
	public boolean isOff();
	public void apply();
}


public class Particle {

  protected Vector3D position;
  protected Vector3D initialPosition;  
  protected Vector3D velocity;
  protected Vector3D force;
  protected float mass;
  protected float age;
  protected boolean dead;
  boolean fixed;
  protected int id;
  ArrayList<Particle> linkedNodes;
  
 // ArrayList springs;

  public Particle( float m )
  {
    position = new Vector3D();
    initialPosition = new Vector3D();
    velocity = new Vector3D();
    force = new Vector3D();
    mass = m;
    fixed = false;
    age = 0;
    dead = false;
    linkedNodes = new ArrayList();
    //ArrayList springs = new ArrayList();
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#distanceTo(traer.physics.Particle)
   
   */

  public final float distanceTo( Particle p )

  {

    return this.position().distanceTo( p.position() );
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#makeFixed()
   
   */

  public final void makeFixed()

  {

    fixed = true;

    velocity.clear();
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#isFixed()
   
   */

  public final boolean isFixed()

  {

    return fixed;
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#isFree()
   
   */

  public final boolean isFree()

  {

    return !fixed;
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#makeFree()
   
   */

  public final void makeFree()

  {

    fixed = false;
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#position()
   
   */

  public final Vector3D position()

  {

    return position;
  }

public final Vector3D initialPosition()

  {

    return initialPosition;
  }



  public final Vector3D velocity()

  {

    return velocity;
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#mass()
   
   */

  public final float mass()

  {

    return mass;
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#setMass(float)
   
   */

  public final void setMass( float m )

  {

    mass = m;
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#force()
   
   */

  public final Vector3D force()

  {

    return force;
  }



  /* (non-Javadoc)
   
   * @see traer.physics.AbstractParticle#age()
   
   */

  public final float age()

  {

    return age;
  }



  protected void reset()

  {

    age = 0;

    dead = false;

    position.clear();

    velocity.clear();

    force.clear();

    mass = 1f;
  }
}



public class ParticleSystem {

  public static final int RUNGE_KUTTA = 0;
  public static final int MODIFIED_EULER = 1;
  protected static final float DEFAULT_GRAVITY = 0;
  protected static final float DEFAULT_DRAG = 0.001f;	
  ArrayList particles;
  ArrayList springs;
  ArrayList attractions;
  ArrayList customForces = new ArrayList();
  Integrator integrator;
  Vector3D gravity;
  float drag;
  boolean hasDeadParticles = false;


  public final void setIntegrator( int integrator ) {
    switch ( integrator ) {

    case RUNGE_KUTTA:
      this.integrator = new RungeKuttaIntegrator( this );
      break;

    case MODIFIED_EULER:
      this.integrator = new ModifiedEulerIntegrator( this );
      break;
    }
  }


  public final void setGravity( float x, float y, float z ) {
    gravity.set( x, y, z );
  }



  // default down gravity
  public final void setGravity( float g ) {
    gravity.set( 0, g, 0 );
  }



  public final void setDrag( float d )

  {

    drag = d;
  }



  public final void tick()

  {

    tick( 1 );
  }



  public final void tick( float t )

  {  

    integrator.step( t );
  }



  public final Particle makeParticle(int id, float mass, float x, float y, float z )
  {
    Particle p = new Particle( mass );
    p.position().set( x, y, z );
    p.initialPosition().set(x, y, z);
    p.id = id;
    particles.add( p );
    return p;
  }



  public final Particle makeParticle()

  {  

    return makeParticle(0, 1.0f, 0f, 0f, 0f );
  }



  public final Spring makeSpring( Particle a, Particle b, float ks, float d, float r )

  {

    Spring s = new Spring( a, b, ks, d, r );
    springs.add( s );

    return s;
  }



  public final Attraction makeAttraction( Particle a, Particle b, float k, float minDistance )

  {

    Attraction m = new Attraction( a, b, k, minDistance );

    attractions.add( m );

    return m;
  }



  public final void clear()

  {

    particles.clear();

    springs.clear();

    attractions.clear();
  }



  public ParticleSystem( float g, float somedrag )

  {

    integrator = new RungeKuttaIntegrator( this );

    particles = new ArrayList();

    springs = new ArrayList();

    attractions = new ArrayList();

    gravity = new Vector3D( 0, g, 0 );

    drag = somedrag;
  }



  public ParticleSystem( float gx, float gy, float gz, float somedrag )

  {

    integrator = new RungeKuttaIntegrator( this );

    particles = new ArrayList();

    springs = new ArrayList();

    attractions = new ArrayList();

    gravity = new Vector3D( gx, gy, gz );

    drag = somedrag;
  }



  public ParticleSystem()

  {

    integrator = new RungeKuttaIntegrator( this );

    particles = new ArrayList();

    springs = new ArrayList();

    attractions = new ArrayList();

    gravity = new Vector3D( 0, ParticleSystem.DEFAULT_GRAVITY, 0 );

    drag = ParticleSystem.DEFAULT_DRAG;
  }



  protected final void applyForces()

  {

    if ( !gravity.isZero() )

    {

      for ( int i = 0; i < particles.size(); ++i )

      {

        Particle p = (Particle)particles.get( i );

        p.force.add( gravity );
      }
    }



    for ( int i = 0; i < particles.size(); ++i )

    {

      Particle p = (Particle)particles.get( i );

      p.force.add( p.velocity.x() * -drag, p.velocity.y() * -drag, p.velocity.z() * -drag );
    }



    for ( int i = 0; i < springs.size(); i++ )

    {

      Spring f = (Spring)springs.get( i );

      f.apply();
    }



    for ( int i = 0; i < attractions.size(); i++ )

    {

      Attraction f = (Attraction)attractions.get( i );

      f.apply();
    }



    for ( int i = 0; i < customForces.size(); i++ )

    {

      Force f = (Force)customForces.get( i );

      f.apply();
    }
  }



  protected final void clearForces()

  {

    Iterator i = particles.iterator();

    while ( i.hasNext() )

    {
      Particle p = (Particle)i.next();
      p.force.clear();
    }
  }



  public final int numberOfParticles()

  {

    return particles.size();
  }



  public final int numberOfSprings()

  {

    return springs.size();
  }



  public final int numberOfAttractions()

  {

    return attractions.size();
  }



  public final Particle getParticle( int i )

  {

    return (Particle)particles.get( i );
  }



  public final Spring getSpring( int i )

  {

    return (Spring)springs.get( i );
  }



  public final Attraction getAttraction( int i )

  {

    return (Attraction)attractions.get( i );
  }



  public final void addCustomForce( Force f )

  {

    customForces.add( f );
  }



  public final int numberOfCustomForces()

  {

    return customForces.size();
  }



  public final Force getCustomForce( int i )

  {

    return (Force)customForces.get( i );
  }



  public final Force removeCustomForce( int i )

  {

    return (Force)customForces.remove( i );
  }



  public final void removeParticle( Particle p ) {
    Spring currentSpring;
    //\u524a\u9664\u3059\u308bparticle\u306b\u4ed8\u3044\u3066\u3044\u308bspring\u3082\u4e00\u7dd2\u306b\u524a\u9664
    for(int i=0; i<springs.size(); i++) {
      currentSpring = (Spring)springs.get(i);
      if(currentSpring.a == p || currentSpring.b == p) springs.remove(currentSpring);
    }
      particles.remove(p);
  }



  public final Spring removeSpring( int i ) {
    return (Spring)springs.remove( i );
  }



  public final Attraction removeAttraction( int i  )

  {

    return (Attraction)attractions.remove( i );
  }



  public final void removeAttraction( Attraction s )

  {

    attractions.remove( s );
  }



  public final void removeSpring( Spring a )

  {

    springs.remove( a );
  }



  public final void removeCustomForce( Force f )

  {

    customForces.remove( f );
  }


  public final void drawSprings() {
    for(int i=0; i<springs.size(); i++) {
      Spring currentSpring = (Spring)springs.get(i);
      Particle p1 = currentSpring.a;
      Particle p2 = currentSpring.b;
      stroke(255,0,0,100);
      line(p1.position.x(), p1.position.y(), p1.position.z(), p2.position.x(), p2.position.y(), p2.position.z());
    }
  }
  
}





public class RungeKuttaIntegrator implements Integrator

{	

	ArrayList originalPositions;
	ArrayList originalVelocities;
	ArrayList k1Forces;
	ArrayList k1Velocities;
	ArrayList k2Forces;
	ArrayList k2Velocities;
	ArrayList k3Forces;
	ArrayList k3Velocities;
	ArrayList k4Forces;
	ArrayList k4Velocities;

	ParticleSystem s;

	public RungeKuttaIntegrator( ParticleSystem s )

	{

		this.s = s;

		originalPositions = new ArrayList();
		originalVelocities = new ArrayList();
		k1Forces = new ArrayList();
		k1Velocities = new ArrayList();
		k2Forces = new ArrayList();
		k2Velocities = new ArrayList();
		k3Forces = new ArrayList();
		k3Velocities = new ArrayList();
		k4Forces = new ArrayList();
		k4Velocities = new ArrayList();

	}

	

	public final void allocateParticles()

	{

		while ( s.particles.size() > originalPositions.size() )

		{

			originalPositions.add( new Vector3D() );
			originalVelocities.add( new Vector3D() );
			k1Forces.add( new Vector3D() );
			k1Velocities.add( new Vector3D() );
			k2Forces.add( new Vector3D() );
			k2Velocities.add( new Vector3D() );
			k3Forces.add( new Vector3D() );
			k3Velocities.add( new Vector3D() );
			k4Forces.add( new Vector3D() );
			k4Velocities.add( new Vector3D() );

		}

	}

	

	public final void step( float deltaT )

	{	

		allocateParticles();

		/////////////////////////////////////////////////////////

		// save original position and velocities

		

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			if ( p.isFree() )

			{		

				((Vector3D)originalPositions.get( i )).set( p.position );

				((Vector3D)originalVelocities.get( i )).set( p.velocity );

			}

			

			p.force.clear();	// and clear the forces

		}

		

		////////////////////////////////////////////////////////

		// get all the k1 values

		

		s.applyForces();

		

		// save the intermediate forces

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			if ( p.isFree() )

			{

				((Vector3D)k1Forces.get( i )).set( p.force );

				((Vector3D)k1Velocities.get( i )).set( p.velocity );

			}

			

			p.force.clear();

		}

		

		////////////////////////////////////////////////////////////////

		// get k2 values

		

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			if ( p.isFree() )

			{

				Vector3D originalPosition = (Vector3D)originalPositions.get( i );

				Vector3D k1Velocity = (Vector3D)k1Velocities.get( i );

				

				p.position.x = originalPosition.x + k1Velocity.x * 0.5f * deltaT;

				p.position.y = originalPosition.y + k1Velocity.y * 0.5f * deltaT;

				p.position.z = originalPosition.z + k1Velocity.z * 0.5f * deltaT;

				

				Vector3D originalVelocity = (Vector3D)originalVelocities.get( i );

				Vector3D k1Force = (Vector3D)k1Forces.get( i );

				

				p.velocity.x = originalVelocity.x + k1Force.x * 0.5f * deltaT / p.mass;

				p.velocity.y = originalVelocity.y + k1Force.y * 0.5f * deltaT / p.mass;

				p.velocity.z = originalVelocity.z + k1Force.z * 0.5f * deltaT / p.mass;

			}

		}

		

		s.applyForces();



		// save the intermediate forces

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			if ( p.isFree() )

			{

				((Vector3D)k2Forces.get( i )).set( p.force );

				((Vector3D)k2Velocities.get( i )).set( p.velocity );

			}

			

			p.force.clear();	// and clear the forces now that we are done with them

		}

		

		

		/////////////////////////////////////////////////////

		// get k3 values

		

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			if ( p.isFree() )

			{

				Vector3D originalPosition = (Vector3D)originalPositions.get( i );

				Vector3D k2Velocity = (Vector3D)k2Velocities.get( i );

				

				p.position.x = originalPosition.x + k2Velocity.x * 0.5f * deltaT;

				p.position.y = originalPosition.y + k2Velocity.y * 0.5f * deltaT;

				p.position.z = originalPosition.z + k2Velocity.z * 0.5f * deltaT;

				

				Vector3D originalVelocity = (Vector3D)originalVelocities.get( i );

				Vector3D k2Force = (Vector3D)k2Forces.get( i );

				

				p.velocity.x = originalVelocity.x + k2Force.x * 0.5f * deltaT / p.mass;

				p.velocity.y = originalVelocity.y + k2Force.y * 0.5f * deltaT / p.mass;

				p.velocity.z = originalVelocity.z + k2Force.z * 0.5f * deltaT / p.mass;

			}

		}

		

		s.applyForces();

		

		// save the intermediate forces

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			if ( p.isFree() )

			{

				((Vector3D)k3Forces.get( i )).set( p.force );

				((Vector3D)k3Velocities.get( i )).set( p.velocity );

			}

			

			p.force.clear();	// and clear the forces now that we are done with them

		}

		

		

		//////////////////////////////////////////////////

		// get k4 values

		

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			if ( p.isFree() )

			{

				Vector3D originalPosition = (Vector3D)originalPositions.get( i );

				Vector3D k3Velocity = (Vector3D)k3Velocities.get( i );

				

				p.position.x = originalPosition.x + k3Velocity.x * deltaT;

				p.position.y = originalPosition.y + k3Velocity.y * deltaT;

				p.position.z = originalPosition.z + k3Velocity.z * deltaT;

				

				Vector3D originalVelocity = (Vector3D)originalVelocities.get( i );

				Vector3D k3Force = (Vector3D)k3Forces.get( i );

				

				p.velocity.x = originalVelocity.x + k3Force.x * deltaT / p.mass;

				p.velocity.y = originalVelocity.y + k3Force.y * deltaT / p.mass;

				p.velocity.z = originalVelocity.z + k3Force.z * deltaT / p.mass;



			}

		}

		

		s.applyForces();

		

		// save the intermediate forces

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			if ( p.isFree() )

			{

				((Vector3D)k4Forces.get( i )).set( p.force );

				((Vector3D)k4Velocities.get( i )).set( p.velocity );

			}

		}

		

		/////////////////////////////////////////////////////////////

		// put them all together and what do you get?

		

		for ( int i = 0; i < s.particles.size(); ++i )

		{

			Particle p = (Particle)s.particles.get( i );

			p.age += deltaT;

			if ( p.isFree() )

			{

				// update position

				

				Vector3D originalPosition = (Vector3D)originalPositions.get( i );

				Vector3D k1Velocity = (Vector3D)k1Velocities.get( i );

				Vector3D k2Velocity = (Vector3D)k2Velocities.get( i );

				Vector3D k3Velocity = (Vector3D)k3Velocities.get( i );

				Vector3D k4Velocity = (Vector3D)k4Velocities.get( i );

				

				p.position.x = originalPosition.x + deltaT / 6.0f * ( k1Velocity.x + 2.0f*k2Velocity.x + 2.0f*k3Velocity.x + k4Velocity.x );

				p.position.y = originalPosition.y + deltaT / 6.0f * ( k1Velocity.y + 2.0f*k2Velocity.y + 2.0f*k3Velocity.y + k4Velocity.y );

				p.position.z = originalPosition.z + deltaT / 6.0f * ( k1Velocity.z + 2.0f*k2Velocity.z + 2.0f*k3Velocity.z + k4Velocity.z );

				

				// update velocity

				

				Vector3D originalVelocity = (Vector3D)originalVelocities.get( i );

				Vector3D k1Force = (Vector3D)k1Forces.get( i );

				Vector3D k2Force = (Vector3D)k2Forces.get( i );

				Vector3D k3Force = (Vector3D)k3Forces.get( i );

				Vector3D k4Force = (Vector3D)k4Forces.get( i );

				

				p.velocity.x = originalVelocity.x + deltaT / ( 6.0f * p.mass ) * ( k1Force.x + 2.0f*k2Force.x + 2.0f*k3Force.x + k4Force.x );

				p.velocity.y = originalVelocity.y + deltaT / ( 6.0f * p.mass ) * ( k1Force.y + 2.0f*k2Force.y + 2.0f*k3Force.y + k4Force.y );

				p.velocity.z = originalVelocity.z + deltaT / ( 6.0f * p.mass ) * ( k1Force.z + 2.0f*k2Force.z + 2.0f*k3Force.z + k4Force.z );

			}

		}

	}

}
public class Spring implements Force {
  
  float springConstant;
  float damping;
  float restLength;
  Particle a, b;
  boolean on;

  public Spring( Particle A, Particle B, float ks, float d, float r ) {
    springConstant = ks;
    damping = d;
    restLength = r;
    a = A;
    b = B;
    on = true;
  }



  public final void turnOff()

  {

    on = false;
  }



  public final void turnOn()

  {

    on = true;
  }



  public final boolean isOn()

  {

    return on;
  }



  public final boolean isOff()

  {

    return !on;
  }



  public final Particle getOneEnd()

  {

    return a;
  }



  public final Particle getTheOtherEnd()

  {

    return b;
  }



  public final float currentLength()

  {

    return a.position().distanceTo( b.position() );
  }



  public final float restLength()

  {

    return restLength;
  }



  public final float strength()

  {

    return springConstant;
  }



  public final void setStrength( float ks )

  {

    springConstant = ks;
  }



  public final float damping()

  {

    return damping;
  }



  public final void setDamping( float d )

  {

    damping = d;
  }



  public final void setRestLength( float l )

  {

    restLength = l;
  }



  public final void apply()

  {	

    if ( on && ( a.isFree() || b.isFree() ) )

    {

      float a2bX = a.position().x - b.position().x;
      float a2bY = a.position().y - b.position().y;
      float a2bZ = a.position().z - b.position().z;


      float a2bDistance = (float)Math.sqrt( a2bX*a2bX + a2bY*a2bY + a2bZ*a2bZ );



      if ( a2bDistance == 0 )

      {

        a2bX = 0;

        a2bY = 0;

        a2bZ = 0;
      }

      else

      {

        a2bX /= a2bDistance;

        a2bY /= a2bDistance;

        a2bZ /= a2bDistance;
      }





      // spring force is proportional to how much it stretched 

      float springForce = -( a2bDistance - restLength ) * springConstant; 



      // want velocity along line b/w a & b, damping force is proportional to this

      float Va2bX = a.velocity().x - b.velocity().x;
      float Va2bY = a.velocity().y - b.velocity().y;
      float Va2bZ = a.velocity().z - b.velocity().z;
      

      float dampingForce = -damping * ( a2bX*Va2bX + a2bY*Va2bY + a2bZ*Va2bZ );





      // forceB is same as forceA in opposite direction

      float r = springForce + dampingForce;



      a2bX *= r;
      a2bY *= r;
      a2bZ *= r;


      if ( a.isFree() )
      
        a.force().add( a2bX, a2bY, a2bZ );

      if ( b.isFree() )

        b.force().add( -a2bX, -a2bY, -a2bZ );
    }
  }



  protected void setA( Particle p )

  {

    a = p;
  }



  protected void setB( Particle p )

  {

    b = p;
  }
}

public class Vector3D

{

  float x;

  float y;

  float z;



  public Vector3D( float X, float Y, float Z ) { 
    x = X; 
    y = Y; 
    z = Z;
  }

  public Vector3D() { 
    x = 0; 
    y = 0; 
    z = 0;
  }

  public Vector3D( Vector3D p ) { 
    x = p.x; 
    y = p.y; 
    z = p.z;
  }



  public final float z() { 
    return z;
  }

  public final float y() { 
    return y;
  }

  public final float x() { 
    return x;
  }



  public final void setX( float X ) { 
    x = X;
  }

  public final void setY( float Y ) { 
    y = Y;
  }

  public final void setZ( float Z ) { 
    z = Z;
  }



  public final void set( float X, float Y, float Z ) { 
    x = X; 
    y = Y; 
    z = Z;
  }



  public final void set( Vector3D p ) { 
    x = p.x; 
    y = p.y; 
    z = p.z;
  }



  public final void add( Vector3D p ) { 
    x += p.x; 
    y += p.y; 
    z += p.z;
  }

  public final void subtract( Vector3D p ) { 
    x -= p.x; 
    y -= p.y; 
    z -= p.z;
  }



  public final void add( float a, float b, float c ) { 
    x += a; 
    y += b; 
    z += c;
  } 

  public final void subtract( float a, float b, float c ) { 
    x -= a; 
    y -= b; 
    z -= c;
  } 



  public final Vector3D multiplyBy( float f ) { 
    x *= f; 
    y *= f; 
    z*= f; 
    return this;
  }



  public final float distanceTo( Vector3D p ) { 
    return (float)Math.sqrt( distanceSquaredTo( p ) );
  }



  public final float distanceSquaredTo( Vector3D p ) { 
    float dx = x-p.x; 
    float dy = y-p.y; 
    float dz = z-p.z; 
    return dx*dx + dy*dy + dz*dz;
  }



  public final float distanceTo( float x, float y, float z )

  {

    float dx = this.x - x;

    float dy = this.y - y;

    float dz = this.z - z;

    return (float)Math.sqrt( dx*dx + dy*dy + dz*dz );
  }



  public final float dot( Vector3D p ) { 
    return x*p.x + y*p.y + z*p.z;
  }

  public final float length() { 
    return (float)Math.sqrt( x*x + y*y + z*z );
  }

  public final float lengthSquared() { 
    return x*x + y*y + z*z;
  }



  public final void clear() { 
    x = 0; 
    y = 0; 
    z = 0;
  }



  public final String toString() { 
    return new String( "(" + x + ", " + y + ", " + z + ")" );
  }



  public final Vector3D cross( Vector3D p )
  {
    return new Vector3D( 	this.y*p.z - this.z*p.y, 
    this.x*p.z - this.z*p.x,
    this.x*p.y - this.y*p.x );
  }



  public boolean isZero() 
  {
    return x == 0 && y == 0 && z == 0;
  }
  
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "B01_Catenary_Surface_Simulator" });
  }
}
